



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java基础(八)-----深入解析java四种访问权限</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java基础(八)-----深入解析java四种访问权限</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 01:13:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　Java中的访问权限理解起来不难，但完全掌握却不容易，特别是4种访问权限并不是任何时候都可以使用。下面整理一下，在什么情况下，有哪些访问权限可以允许选择。</p>
<h2>一、访问权限简介</h2>
<p><strong>访问权限控制</strong>： 指的是本类及本类内部的成员（成员变量、成员方法、内部类）对其他类的可见性，即这些内容是否允许其他类访问。</p>
<p>Java 中一共有四种访问权限控制，其权限控制的大小情况是这样的：<strong>public &gt; protected &gt; default(包访问权限) &gt; private</strong>&nbsp;,具体的权限控制看下面表格，列所指定的类是否有权限允许访问行的权限控制下的内容：</p>
<table>
<thead>
<tr>
<th>访问权限</th>
<th>本类</th>
<th>本包的类</th>
<th>子类</th>
<th>非子类的外包类</th>
</tr>
</thead>
<tbody>
<tr>
<td>public</td>
<td>是</td>
<td>是</td>
<td>是</td>
<td>是</td>
</tr>
<tr>
<td>protected</td>
<td>是</td>
<td>是</td>
<td>是</td>
<td>否</td>
</tr>
<tr>
<td>default</td>
<td>是</td>
<td>是</td>
<td>否</td>
<td>否</td>
</tr>
<tr>
<td>private</td>
<td>是</td>
<td>否</td>
<td>否</td>
<td>否</td>
</tr>
</tbody>
</table>
<p><strong>1、public：</strong>&nbsp;所修饰的类、变量、方法，在内外包均具有访问权限；<br /><strong>2、protected：</strong>&nbsp;这种权限是为继承而设计的，protected所修饰的成员，对所有子类是可访问的，但只对同包的类是可访问的，对外包的非子类是不可以访问；<br /><strong>3、包访问权限（default）：</strong>&nbsp;只对同包的类具有访问的权限，外包的所有类都不能访问；<br /><strong>4、private：</strong>&nbsp;私有的权限，只对本类的方法可以使用；</p>
<p><strong>注意： 要区分开 protected 权限、包访问权限，正确使用它们；</strong></p>
<ul><li><p>当某个成员能被所有的子类继承，但不能被外包的非子类访问，就是用protected；</p></li>
<li><p>当某个成员的访问权限只对同包的类开放，包括不能让外包的类继承这个成员，就用包访问权限；</p></li></ul>
<p><strong>使用访问权限控制的原因：</strong></p>
<p>1）使用户不要碰触那些他们不该碰触的部分；<br />2）类库设计者可以更改类的内部工作的方式，而不会担心这样会对用户产生重大影响；</p>
<h2>二、访问权限控制的使用场景</h2>
<p>访问权限使用的场景可以总结为下面的五种场景，分别对访问权限的使用有不同的限制：</p>
<h3>1. 外部类的访问控制</h3>
<p><strong>外部类（外部接口）</strong>&nbsp;是相对于内部类（也称为嵌套类）、内部接口而言的。<strong>外部类的访问控制只能是这两种：public 、default</strong>&nbsp;。</p>
<div>
<pre class="prettyprint linenums">//public 访问呢权限的外部类，所有类都可以使用这个类<br />
public class OuterClass {<br />
}<br />
//default 权限的外部接口，所有类、接口均可以使用此接口<br />
interface OuterInterface{<br />
}</pre>
</div>
<h3>2. 类里面的成员的访问控制</h3>
<p>类里面的成员分为三类 ：&nbsp;<strong>成员变量、成员方法、成员内部类（内部接口）</strong></p>
<p><strong>类里面的成员的访问控制可以是四种，也就是可以使用所有的访问控制权限</strong></p>
<div>
<pre class="prettyprint linenums">public class OuterClass {<br />
    public int aa; //可以被所有的类访问<br />
    protected boolean bb; //可以被所有子类以及本包的类使用<br />
    void cc() { //default 访问权限，能在本包范围内使用<br />
        System.out.println("包访问权限");<br />
    }<br />
    //private权限的内部类，即这是私有的内部类，只能在本类使用<br />
    private class InnerClass{<br />
    }<br />
}</pre>
</div>
<p><strong>注意：</strong><br />这里的类里面的成员 是指类的全局成员，并没有包括局部的成员（局部变量、局部内部类，没有局部内部接口）。或者说，<strong>局部成员是没有访问权限控制的</strong>，因为局部成员只在其所在的作用域内起作用，不可能被其他类访问到。</p>
<div>
<pre class="prettyprint linenums">public void count(){<br />
    //局部成员变量<br />
    public int amount;//编译无法通过，不能用public修饰<br />
    int money;//编译通过<br />
    //局部嵌套接口<br />
    class customer{//编译通过<br />
    }<br />
}</pre>
</div>
<h3>3. 抽象方法的访问权限</h3>
<p>普通方法是可以使用四种访问权限的，<strong><strong>但抽象方法是有一个限制：不能用private 来修饰，也即抽象方法不能是私有的，否则，子类就无法继承实现抽象方法</strong>。</strong></p>
<h3>4. 接口成员的访问权限</h3>
<p>接口由于其的特殊性，所有成员的访问权限都规定得死死的，下面是接口成员的访问权限：</p>
<ul><li><p>变量： public static final</p></li>
<li><p>抽象方法： public abstract</p></li>
<li><p>静态方法： public static，JDK1.8后才支持</p></li>
<li><p>内部类、内部接口 ： public static</p></li></ul>
<p>也因为所有的一切都默认强制规定好了，所以我们在用的时候，并不一定需要完整写出所有的修饰符，编译器会帮我们完成的，也就是，可以少写修饰符，但不能写错修饰符。</p>
<div>
<pre class="prettyprint linenums">public interface Interface_Test {<br />
    public int aa = 6; //少写了  static final<br />
    int bb = 5; //<br />
    //嵌套接口，可以不写public static<br />
     interface cc{<br />
    }<br />
}</pre>
</div>
<h3>5. 构造器的访问权限</h3>
<p><strong>构造器的访问权限可以是以上四种权限中的任意一种：</strong></p>
<p>1、采用 private：一般是不允许直接构造这个类的对象，再结合工厂方法（static方法），实现单例模式。注意：所有子类都不能继承它。<br />2、采用包访问控制：比较少用，这个类的对象只能在本包中使用，但是如果这个类有static 成员，那么这个类还是可以在外包使用；（也许可以用于该类的外包单例模式）。<br />注意：外包的类不能继承这个类；<br />3、采用 protected ：就是为了能让所有子类继承这个类，但是外包的非子类不能访问这个类；<br />4、采用 public ：对于内外包的所有类都是可访问的；</p>
<p><strong>注意：</strong>&nbsp;构造方法有点特殊，因为子类的构造器初始化时，都要调用父类的构造器，所以<strong>一旦父类构造器不能被访问，那么子类的构造器调用失败，意味子类继承父类失败！</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z14o19.html">BZOJ 1212&colon; &lbrack;HNOI2004&rsqb;L语言 &lbrack;AC自动机 DP&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jzgzl8.html">3 3Sum closest&lowbar;Leetcode</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkp0l9.html">TCP</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdggj78.html">greenDao 学习之坑 &amp;quot&semi;java-gen&amp;quot&semi; 目录下的类不能引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mnpx1q.html">如何在ARC代码中混编非ARC代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj40w5q.html">Apache &period;htaccess语法之RewriteRule</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvx5xq.html">SQL语句的优化建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrkye8.html">Spring Boot通过命令行启动发生FileNotFoundException</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y0ryr8.html">Java-接口&lpar;interface&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy14dn9.html">fiddler近期用到的一些新功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r152j9.html">CSS&vert; 學習心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7owpzk8.html">Gitlab库已损坏前端显示500错误解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m21rwpq.html">对偶上升法到增广拉格朗日乘子法到ADMM</a>
		</li>
						<li><a href="https://www.batexi.com/a/960vng39.html">chattr和lsattr命令的使用（对于root用户也无法修改删除的操作问题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m23nmrq.html">Delphi 泛型详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgrmeq.html">day 19 类的名称空间，组合，派生</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1l4e19.html">【Android开发】之Android环境搭建及HelloWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em4v4z9.html">Visual F&num; Power Tools 简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjgmm0q.html">通过应用程序域AppDomain加载和卸载程序集</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj3k1zq.html">ab&comma;qps&comma;服务器性能压力</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwjmg4z8.html">python实现四则运算和效能分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pwrr38.html">设计模式的征途&mdash;13&period;代理（Proxy）模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jlz4v8.html">源码分析Session的台前幕后&lpar;Asp &period;Net MVC5&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zykze9.html">Java基础系列--桶排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgre578.html">Maven项目打包为jar的几种方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj070eq.html">Linux内存使用情况以及内存泄露分析之工具与方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj0xeeq.html">JAVA PERSISTENCE API &lpar;JPA&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pw6138.html">nake&lowbar;api&lowbar;protect 请求保护器&mdash;&mdash;防止请求被恶意刷</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd4nw79.html">C&num;中的is和as</a>
			</li>
						<li><a href="https://www.batexi.com/a/96prjy48.html">Vector简单介绍</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
